library ieee; 
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all; 
use ieee.std_logic_misc.all;

entity PISOsr is    
generic (
		size : natural := 1
		);	
port(	
	compclk: in std_logic;								--Clock with witch the Data are Output
	assign: in std_logic;								--Assigns the data on 'dout' to the Register deletes old data
	empty: out std_logic:='1';							--Signals that the 24'th bit ist visible on 'dout'
	din: in std_logic_vector(size downto 0);	--Data Input
	dout: out std_logic									--Data Output
); 
end PISOsr;

architecture PISOsr_arch of PISOsr is

begin

	PISOsr : process (compclk, assign)
		variable data_register : std_logic_vector(size+1 downto 0); 
	begin
		if  (assign='1') then
				data_register(size+1 downto 1) :=din;
				data_register(0):='1';
			
		elsif (rising_edge(compclk)) then
			if (or_reduce(data_register(size downto 0))= '0') then 
				empty<='1';
				dout <= '0';
			else 
				dout <= data_register(size+1);
				data_register(size+1 downto 1) := data_register(size downto 0);
				data_register(0):='0';
				empty<='0';
			end if;	
		end if;

	end process PISOsr;
end PISOsr_arch; 