library ieee; 
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all; 


entity PrescalerSCK is    
generic (
		divider : natural := 1
		);	
port(	
	compclk: in std_logic;									--Clock with witch the Data are Output
	clkout: out std_logic:='0'								--Enables the Clock Input
); 
end PrescalerSCK;

architecture PrescalerSCK_arch of PrescalerSCK is

begin
	PrescalerSCK : process (compclk)
	
	variable counter : natural range 0 to divider :=0;
	variable outx : std_logic := '0';
	
	begin
		
	if (rising_edge(compclk)) then
		counter:=counter+1;
		if (counter=divider) then 
			outx := not outx;
			counter:=0;
		end if; 
	end if;		
	clkout <= outx;
	end process PrescalerSCK;
end PrescalerSCK_arch; 