library ieee; 
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all; 


entity Trigger is    
generic (
		cycles : natural := 1
		);	
port(	
	compclk: in std_logic;
	key: in std_logic;									--Clock with witch the Data are Output
	cmd: buffer std_logic:='0'								--Enables the Clock Input
); 
end Trigger; 

architecture Trigger_arch of Trigger is

begin
	Trigger : process (compclk)
	
	variable debounce : integer range 0 to cycles :=0;
	
	begin
	
	if (rising_edge(compclk) ) then
		if(key='1') then
			debounce:=1;
		end if;
		cmd <= '0';
		
		if (debounce=cycles-1) then 
			cmd <= '1';
			debounce:=debounce+1;
		elsif (debounce=cycles) then 
			
			debounce:=0;
		elsif (debounce=0) then
		elsif (debounce>0) then
			debounce:=debounce+1;
			cmd <= '0';
		end if; 
	end if;		
	
	end process Trigger;
end Trigger_arch; 