-- VHDL testbench template generated by SCUBA Diamond (64-bit) 3.7.0.96.1
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

use IEEE.math_real.all;

use IEEE.numeric_std.all;

entity tb is
end entity tb;


architecture test of tb is 

    component SiCoSiTable
        port (Clock: in std_logic; ClkEn: in std_logic; 
        Reset: in std_logic; Theta : in std_logic_vector(7 downto 0); 
        Sine : out std_logic_vector(15 downto 0); 
        Cosine : out std_logic_vector(15 downto 0)
    );
    end component;

    signal Clock: std_logic := '0';
    signal ClkEn: std_logic := '0';
    signal Reset: std_logic := '0';
    signal Theta : std_logic_vector(7 downto 0) := (others => '0');
    signal Sine : std_logic_vector(15 downto 0);
    signal Cosine : std_logic_vector(15 downto 0);
begin
    u1 : SiCoSiTable
        port map (Clock => Clock, ClkEn => ClkEn, Reset => Reset, Theta => Theta, 
            Sine => Sine, Cosine => Cosine
        );

    Clock <= not Clock after 5.00 ns;

    process

    begin
      ClkEn <= '0' ;
      wait for 100 ns;
      wait until Reset = '0';
      ClkEn <= '1' ;
      wait;
    end process;

    process

    begin
      Reset <= '1' ;
      wait for 100 ns;
      Reset <= '0' ;
      wait;
    end process;

    process

    begin
      Theta <= (others => '0') ;
      wait for 100 ns;
      wait until Reset = '0';
      for i in 0 to 259 loop
        wait until Clock'event and Clock = '1';
        Theta <= Theta + '1' after 1 ns;
      end loop;
      wait;
    end process;

end architecture test;
